<template>
  <div>
    <pre v-if="location"
      >{{ location.lat.toFixed(5) }}N {{ location.lng.toFixed(5) }}E</pre
    >
    <el-form v-if="map">
      <el-form-item>
        <el-checkbox v-model="showSatellite">Satellite</el-checkbox>
      </el-form-item>
      <el-form-item v-if="showSatellite">
        <el-slider v-model="satelliteOpacity" :min="0" :max="100" :step="1"
          >Satellite Opacity</el-slider
        >
      </el-form-item>
    </el-form>

    <el-checkbox v-model="showOwnership">Land Ownership</el-checkbox>

    <p v-if="owner">
      Owner:

      <span v-if="owner.properties.admin_agency_code == 'PVT'"
        >Private Owner</span
      >
      <span v-else-if="owner.properties.admin_agency_code == 'LG'"
        >Local Government</span
      >
      <span v-else-if="owner.properties.admin_agency_code == 'ST'"
        >State Government</span
      >
      <span v-else
        >{{ owner.properties.admin_agency_code }}:
        {{ owner.properties.admin_unit_name }}</span
      >
    </p>

    <client-only>
      <portal to="map">
        <MglConfig ref="config" @mousemove="mouseMove" />
      </portal>
    </client-only>
  </div>
</template>
<script>
import MapReference from "~/mixins/MapReference";
import MglConfig from "./MglConfig";

export default {
  // TODO: Make it support taking a param?
  mixins: [MapReference],
  components: { MglConfig },
  data() {
    return {
      location: null,
      owner: null,
      showSatellite: false,
      showOwnership: false,
      satelliteOpacity: 100,
    };
  },

  beforeDestroy() {
    this.setLayoutProperty("satellite", "visibility", "none");
    this.setPaintProperty("satellite", "raster-opacity", 1);
    this.setLayoutProperty("ownership-line", "visibility", "none");
    this.setLayoutProperty("ownership-fill", "visibility", "none");
  },

  computed: {
    /*showSatellite: {
      get() {
        const viz =
          this.map && this.map.map.getLayoutProperty("satellite", "visibility");
        console.log("VIZ: ", viz);
        return viz && viz != "none";
      },
      set(value) {
              this.map.map.setLayoutProperty(
          "satellite",
          "visibility",
          value ? "visible" : "none"
        );
      }
    }*/
  },
  watch: {
    showSatellite: {
      immediate: true,
      handler(value) {
        this.setLayoutProperty(
          "satellite",
          "visibility",
          value ? "visible" : "none"
        );
      },
    },
    satelliteOpacity: {
      immediate: true,
      handler(value) {
        this.setPaintProperty("satellite", "raster-opacity", value / 100.0);
      },
    },
    showOwnership: {
      immediate: true,
      handler(value) {
        this.setLayoutProperty(
          "ownership-line",
          "visibility",
          value ? "visible" : "none"
        );

        this.setLayoutProperty(
          "ownership-fill",
          "visibility",
          value ? "visible" : "none"
        );
      },
    },
  },
  methods: {
    mouseMove(event) {
      this.location = { lng: event.lngLat.lng, lat: event.lngLat.lat };

      const owners = this.map.map.queryRenderedFeatures(event.point, {
        layers: ["ownership-fill"],
      });

      this.owner =
        owners.find((o) => o.properties.admin_agency_code != "PVT") ||
        owners[0];
    },
    getPaintProperty(...args) {
      if (this.map && this.map.map) {
        return this.map.map.getPaintProperty(...args);
      }
      return null;
    },
    getLayoutProperty(...args) {
      if (this.map && this.map.map) {
        return this.map.map.getLayoutProperty(...args);
      }
      return null;
    },
    setPaintProperty(...args) {
      if (this.map && this.map.map) {
        return this.map.map.setPaintProperty(...args);
      }
    },
    setLayoutProperty(...args) {
      if (this.map && this.map.map) {
        return this.map.map.setLayoutProperty(...args);
      }
    },
  },
};
</script>
